; Segment type:	Regular
ext_C000	jp	runAdr
; ---------------------------------------------------------------------------
ext_C003	jp	loc_C155
; ---------------------------------------------------------------------------
ext_C006	jp	extGameOver
; ---------------------------------------------------------------------------

runAdr:		di
		ld	hl, 6000h
		ld	de, 6001h
		ld	bc, 100h
		ld	a, h
		ld	i, a
		inc	a
		ld	(hl), a
		ldir
		im	2
		call	aniOff
		call	cursorOff
		ld	c, 0
		call	setMusic
		ei
loc_C028:	call	rmArrow
		call	cls
		ld	hl, pakMenuScr
		ld	de, freeSpace
		call	deHrust2
		ld	hl, freeSpace
		ld	de, 4000h
		ld	bc, 1B00h
		ldir
		call	cursorOn
loc_C045:	call	inKeys
		cp	0Ah
		jr	z, menDown
		cp	0Bh
		jr	z, menUp
		cp	20h
		jr	nz, loc_C045
		call	cursorOff
		call	rmMenuCursor
		ld	a, (menCrsPos+1)
		and	a
		jp	z, start
		dec	a
		jp	nz, exitGame
		call	noKey
		call	cursorOff
		call	rmMenuCursor
		ld	hl, pakAboutScr
		ld	de, freeSpace
		call	deHrust2
		ld	hl, 5800h
		ld	de, 5801h
		ld	bc, 2FFh
		ld	(hl), l
		ldir
		ld	hl, freeSpace
		ld	de, 4000h
		ld	bc, 1B00h
		ldir
		call	waitKey
		call	noKey
		jp	loc_C028

menDown:	ld	a, (menCrsPos+1)
		cp	2
		jr	nc, loc_C045
		inc	a
loc_C09F:	push	af
		call	cursorOff
		call	rmMenuCursor
		pop	af
		ld	(menCrsPos+1), a
		call	cursorOn
		ld	b, 0Ah
loc_C0AF:	halt
		djnz	loc_C0AF
		jr	loc_C045


menUp:		ld	a, (menCrsPos+1)
		sub	1
		jr	c, loc_C045
		jr	loc_C09F
; ---------------------------------------------------------------------------
		ld	de, 8
loc_C0C0:	ld	(printPos+1), de
		ld	a, e
		cp	10h
		ret	nc
loc_C0C8:	ld	a, (hl)
		and	a
		scf
		ret	z
		inc	hl
		inc	e
		cp	0Dh
		jr	z, loc_C0C0
		dec	e
		cp	20h
		call	nc, printChar
		jr	loc_C0C8

fillHLC:	ld	(hl), c
		inc	l
		djnz	fillHLC
		ret

; ---------------------------------------------------------------------------
; switch cursor flashing
cursorOn:	ld	a, 0A7h
		jr	loc_C0E5
cursorOff:	ld	a, 37h
loc_C0E5:	ld	(crsFlag), a
		ret

rmMenuCursor:	ld	a, (swMenuCursor+1)
		and	a
		ret	z
swMenuCursor:	ld	a, 0
		cpl
		ld	(swMenuCursor+1), a
menCrsPos:	ld	hl, 0
		ld	de, cursorData
		add	hl, hl
		add	hl, hl
		add	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	b, 3
loc_C107:	ld	c, l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	a, (de)
		xor	(hl)
		ld	(hl), a
		inc	de
		inc	l
		ld	l, c
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_C107
		ld	a, l
		add	a, 20h ; ' '
		ld	l, a
		jr	c, loc_C146
		ld	a, h
		sub	8
		ld	h, a
loc_C146:	djnz	loc_C107
		ret
; ---------------------------------------------------------------------------
cursorData:	dw unk_E086,40ECh	; <crs.adr>,<scr.adr>
		dw unk_E15E,484Ch
		dw unk_E22D,4F8Ch
; ---------------------------------------------------------------------------

loc_C155:
		jp loc_61FB
/*
		di			; original : load final video & run it
		ld	a, 3Fh ; '?'
		ld	i, a
		im	1
		ei
		ld	hl, 6161h
		ld	de, (word_616A)
		ld	bc, 605h
		call	3D13h
		ld	de, (5CF4h)
		jp	start
*/
; ---------------------------------------------------------------------------

extGameOver:	call	rmArrow
		ld	hl, 5800h
		ld	de, 5801h
		ld	bc, 3FFh
		ld	(hl), l
		ldir
		ld	hl, pakGOverScr
		ld	de, freeSpace
		call	deHrust2
		ld	hl, freeSpace
		ld	de, 4000h
		ld	bc, 1B00h
		ldir
		call	noKey
		call	waitKey
		call	noKey
		ld	c, 0
		call	setMusic
		ei
		jp	loc_C028

cls:		ld	hl, 4000h
		ld	de, 4001h
		ld	bc, 1800h
		ld	(hl), l
		ldir
		ld	bc, 2FFh
		ld	(hl), 7
		ldir
		xor	a
		out	(0FEh),	a
		ret

; ---------------------------------------------------------------------------
pakMenuScr	incbin "menuScr.pak"
pakAboutScr:	incbin "aboutScr.pak"
pakGOverScr:	incbin "overScr.pak"
; menu cursors
unk_E086:	incbin "cursor1.bin"
unk_E15E:	incbin "cursor2.bin"
unk_E22D:	incbin "cursor3.bin"
