; VQ1 npc animator

animate:	ld	ix, (npcTabAdr)
loc_7237:	bit	7, (ix+0)
		ret	nz
		ld	a, (ix+4)
		inc	a
		jr	nz, loc_725A
		ld	a, (ix+3)
		inc	a
		jr	z, loc_727A
		ld	a, (ix+5)
		and	a
		jr	z, loc_727A
		ld	(ix+5),	0
		ld	a, (ix+3)
		call	setNpcSprite
		jr	loc_727A
loc_725A:	dec	(ix+5)
		jr	nz, loc_727A
		ld	l, (ix+15h)
		ld	h, (ix+16h)
		ld	a, (hl)
		sub	0F0h
		jr	nc, aniCom
		ld	a, (hl)
		ld	(ix+5),	a
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	(ix+15h), l
		ld	(ix+16h), h
		call	setNpcSprite
loc_727A:	ld	de, 20h
		add	ix, de
		jr	loc_7237
aniCom:		push	hl
		ld	hl, aniComTab
		add	a, a
		add	a, l
		ld	l, a
		jr	nc, loc_728B
		inc	h
loc_728B:	call	ldHL_HL
		ld	(loc_7293+1), hl
		pop	hl
		inc	hl
loc_7293:	call	aniF8
		ld	(ix+15h), l
		ld	(ix+16h), h
		ld	(ix+5),	1
		jr	loc_727A

aniComTab:	dw aniF0, aniF1, aniF2, aniF3
		dw aniF4, aniF5, aniF6, aniF7
		dw aniF8, aniF9, aniFA, aniFB
		dw aniFC, aniFD, aniFE, aniFF

; FF : stop animation
aniFF:		ld	(ix+4),	0FFh
		scf
		ret
		
; FE : go to animation start
aniFE:		ld	l, (ix+13h)
		ld	h, (ix+14h)
loc_72CE:	ld	(ix+15h), l
		ld	(ix+16h), h
		ld	(ix+5),	1
		ret
	
; FD, n : set animation
aniFD:		ld	a, (hl)
setNPCani:	ld	(ix+4),	a
		ld	l, a
		ld	h, 0
		add	hl, hl
		ld	e, (ix+11h)
		ld	d, (ix+12h)
		add	hl, de
		call	ldHL_HL
		ld	(ix+13h), l
		ld	(ix+14h), h
		jr	loc_72CE

; FC	move up
aniFC:		ld	a, (ix+2)
		and	38h
		jr	z, loc_7304
		ld	a, (ix+2)
		sub	8
		ld	b, (ix+1)
		jr	loc_735E
loc_7304:	ld	a, (upMapNr)
		ld	b, a
		ld	a, (ix+2)
		or	38h
		jr	loc_735E
		
; FB	move down
aniFB:		ld	a, (ix+2)
		cp	38h
		jr	nc, loc_731D
		add	a, 8
		ld	b, (ix+1)
		jr	loc_735E
loc_731D:	ld	a, (dnMapNr)
		ld	b, a
		ld	a, (ix+2)
		and	7
		jr	loc_735E

; FA	move left
aniFA:				
		ld	a, (ix+2)
		and	7
		jr	z, loc_7338
		ld	a, (ix+2)
		dec	a
		ld	b, (ix+1)
		jr	loc_735E
loc_7338:	ld	a, (lfMapNr)
		ld	b, a
		ld	a, (ix+2)
		or	7
		jr	loc_735E
		
; F9	move right
aniF9:		ld	a, (ix+2)
		and	7
		cp	7
		jr	z, loc_7355
		ld	a, (ix+2)
		inc	a
		ld	b, (ix+1)
		jr	loc_735E
loc_7355:	ld	a, (rgMapNr)
		ld	b, a
		ld	a, (ix+2)
		and	38h
loc_735E:	ld	c, a
		ld	(ix+0Ah), b
		ld	(ix+0Bh), c
		ld	a, b
		inc	a
		jr	z, loc_737E
		push	hl
		call	getCellTile
		pop	hl
		rla
		jr	c, loc_737E
		ld	a, (ix+1)
		cp	(ix+0Ah)
		ld	e, (hl)
		inc	hl
		ret	z
		ld	d, 0
		add	hl, de
		ret
loc_737E:	dec	hl
		ld	a, (ix+0)
		cp	10h
		ret	nc
		jp	aniFF

; F7
aniF7:				
		ld	e, (ix+1)
		ld	d, (ix+2)
		ld	a, (ix+6)
		ld	(ix+7),	e
		ld	(ix+8),	d
		ld	(ix+9),	a
		ret

; F6
aniF6:				
		ld	b, (ix+0Ah)
		ld	c, (ix+0Bh)
		ld	(ix+1),	b
		ld	(ix+2),	c
		push	hl
		call	getCellAdr
		call	mapBank
		ld	a, (hl)
		ld	(hl), 0FFh
		ld	l, a
		call	wrkBank
		ld	(ix+6),	l
		pop	hl
		ld	a, (curMap)
		cp	b
		ret	nz
		push	hl
		ld	b, 0
		ld	hl, mapBuf
		add	hl, bc
		ld	(hl), 0FFh
		pop	hl
		ret

; F5
aniF5:				
		ld	b, (ix+7)
		ld	c, (ix+8)
		ld	d, (ix+9)
		jr	loc_73DD
		
; F4
aniF4:				
		ld	b, (ix+1)
		ld	c, (ix+2)
		ld	d, (ix+6)
loc_73DD:	push	hl
		call	getCellAdr
		call	mapBank
		ld	(hl), d
		call	wrkBank
		pop	hl
		ld	a, (curMap)
		cp	b
		ret	nz
		push	hl
		ld	hl, mapBuf
		ld	b, 0
		add	hl, bc
		ld	(hl), d
		pop	hl
		ret

; F3
aniF3:				
		ld	a, (curMap)
		cp	(ix+0Ah)
		ret	z
		set	6, (ix+1Dh)
		jp	aniOff
		
; F2,n,e	if rnd >= n jr +e
aniF2:		call	getRandom
		cp	(hl)
		inc	hl
		ld	e, (hl)
		ld	d, 0
		inc	hl
		ret	c
		add	hl, de
		ret

; F1,e		jr +e
aniF1:				
		ld	e, (hl)
		inc	hl
		ld	d, 0
		add	hl, de
		ret

; F0
aniF0:				
		ld	(ix+3),	0FFh
		ld	(ix+4),	0FFh
		push	hl
		call	loc_7504
		pop	hl
		ret
