; === ARROW

setArrowA	ld	hl, arrowSpriteA
		jr	loc_772C
setArrowB	ld	hl, arrowSpriteB
loc_772C:	ld	de, (arrSprAdr+1)
		ld	(arrSprAdr+1), hl
		and	a
		sbc	hl, de
		jr	nz, loc_773D
		ld	a, (rmArrow)
		and	a
		ret	z
loc_773D:	call	rmArrow
		jp	putArrow

arrKeys:	ld	hl, (arrowXY+1)
		ld	a, 0FAh
		in	a, (0DFh)
		or	7
		inc	a
		jr	nz, loc_778E
loc_774F:	ld	de, 0
		call	getMouseX
		ld	(loc_774F+1), a
		sub	e
		jp	m, loc_7767
		add	a, l
		jr	c, loc_7763
		cp	0FCh
		jr	c, loc_776F
loc_7763:	ld	a, 0FCh
		jr	loc_776F
loc_7767:	neg
		ld	e, a
		ld	a, l
		sub	e
		jr	nc, loc_776F
		xor	a
loc_776F:	ld	l, a
		call	getMouseY
		ld	(loc_774F+2), a
		sub	d
		jp	m, loc_7785
		add	a, h
		jr	c, loc_7781
		cp	0BEh
		jr	c, loc_778D
loc_7781:	ld	a, 0BEh
		jr	loc_778D
loc_7785:	neg
		ld	d, a
		ld	a, h
		sub	d
		jr	nc, loc_778D
		xor	a
loc_778D:	ld	h, a
loc_778E:	push	hl
		call	sub_78A7
		pop	hl
		ld	d, 2
		bit	1, c
		jr	z, loc_779F
		ld	a, l
		sub	d
		jr	nc, loc_779E
		xor	a
loc_779E:	ld	l, a
loc_779F:	bit	0, c
		jr	z, loc_77AE
		ld	a, l
		add	a, d
		jr	c, loc_77AB
		cp	0FCh
		jr	c, loc_77AD
loc_77AB:	ld	a, 0FCh
loc_77AD:	ld	l, a
loc_77AE:	bit	3, c
		jr	z, loc_77B8
		ld	a, h
		sub	d
		jr	nc, loc_77B7
		xor	a
loc_77B7:	ld	h, a
loc_77B8:	bit	2, c
		jr	z, loc_77C5
		ld	a, h
		add	a, d
		cp	0BEh
		jr	c, loc_77C4
		ld	a, 0BEh
loc_77C4:	ld	h, a
loc_77C5:	ld	(loc_77FB+1), hl
		halt
		push	bc
		ld	de, (arrowXY+1)
		and	a
		sbc	hl, de
		call	nz, loc_77F8
		pop	bc
		and	a
		bit	4, c
		ret	z
		xor	a
		scf
		ret

getMouseX:	ld	a, 0FBh
		in	a, (0DFh)
		ret

getMouseY:	ld	a, 0FFh
		in	a, (0DFh)
		cpl
		add	a, 0C1h
		ret

noMove:		push	af
		call	getMouseX
		ld	(loc_774F+1), a
		call	getMouseY
		ld	(loc_774F+2), a
		pop	af
		ret

loc_77F8:	call	rmArrow
loc_77FB:	ld	hl, 0
		ld	(arrowXY+1), hl
putArrow:	nop
		xor	a
		call	loc_787B
		ld	bc, (arrowXY+1)
		ld	a, 0C0h
		sub	b
		jr	z, loc_7865
		jr	c, loc_7865
		cp	8
		jr	c, loc_7817
		ld	a, 8
loc_7817:	ld	e, a
		call	sub_78D7
		ld	b, e
		push	hl
arrSprAdr:	ld	hl, arrowSpriteA
loc_7820:	ld	(loc_785E+1), bc
		ld	a, c
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	de, 0FFh
		and	7
		jr	z, loc_783C
loc_7830:	srl	b
		rr	d
		scf
		rr	c
		rr	e
		dec	a
		jr	nz, loc_7830
loc_783C:	ex	(sp), hl
		ld	a, (hl)
		and	c
		or	b
		ld	(hl), a
		ld	a, l
		inc	a
		and	1Fh
		jr	z, loc_784D
		inc	l
		ld	a, (hl)
		and	e
		or	d
		ld	(hl), a
		dec	l
loc_784D:	inc	h
		ld	a, h
		and	7
		jr	nz, loc_785D
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_785D
		ld	a, h
		sub	8
		ld	h, a
loc_785D:	ex	(sp), hl
loc_785E:	ld	bc, 0
		djnz	loc_7820
		inc	sp
		inc	sp
loc_7865:	ld	a, 0C9h
		ld	(putArrow), a
		xor	a
		ld	(rmArrow), a
		ret
		
rmArrow:	ret
		xor	a
		ld	(putArrow), a
		ld	a, 0C9h
		ld	(rmArrow), a
		ld	a, 0EBh
loc_787B:	ld	(loc_789E), a
		ld	(loc_7899), a
arrowXY:	ld	bc, 0
		ld	a, 0C0h
		sub	b
		ret	c
		ret	z
		cp	8
		jr	c, loc_788F
		ld	a, 8
loc_788F:	ld	e, a
		call	sub_78D7
		ld	b, e
		ld	de, arrowBuf
		ld	c, 0FFh
loc_7899:	ex	de, hl
		ldi
		ldi
loc_789E:	ex	de, hl
		dec	hl
		dec	hl
		call	nextHL
		djnz	loc_7899
		ret

sub_78A7:	ld	a, 0FAh
		in	a, (0DFh)
		ld	l, a
		or	7
		inc	a
		ld	c, 0
		jr	nz, loc_78B9
		rr	l
		jr	c, loc_78B9
		ld	c, 10h
loc_78B9:	ld	hl, arrKeyTabA
		ld	a, 0FEh
		in	a, (0FEh)
		and	1
		jr	nz, loc_78C7
		ld	hl, arrKeyTabB
loc_78C7:	ld	a, (hl)
		and	a
		ret	z
		in	a, (0FEh)
		inc	hl
		and	(hl)
		inc	hl
		jr	nz, loc_78D4
		ld	a, c
		or	(hl)
		ld	c, a
loc_78D4:	inc	hl
		jr	loc_78C7
		
sub_78D7:				
		ld	a, b
		and	a
		rra
		scf
		rra
		and	a
		rra
		xor	b
		and	0F8h
		xor	b
		ld	h, a
		ld	a, c
		rlca
		rlca
		rlca
		xor	b
		and	0C7h
		xor	b
		rlca
		rlca
		ld	l, a
		ret

arrowSpriteA:	db 0, 0BFh, 40h, 1Fh, 60h, 0Fh,	70h, 7,	78h, 3,	60h, 7,	40h, 1Fh, 0, 0BFh 
arrowSpriteB:	db 0, 0DFh, 20h, 8Fh, 20h, 87h,	38h, 83h, 7Ch, 1, 7Ch, 1, 38h, 83h, 0, 87h 

arrKeyTabA:	db 0xEF, 0x01, 0x10
		db 0xEF, 0x02, 0x08
		db 0xEF, 0x04, 0x04
		db 0xEF, 0x08, 0x01
		db 0xEF, 0x10, 0x02
arrKeyTabB:	db 0x7F, 0x01, 0x10
		db 0x7F, 0x04, 0x10
		db 0xDF, 0x01, 0x01
		db 0xDF, 0x02, 0x02
		db 0xFB, 0x01, 0x08
		db 0xFD, 0x01, 0x04
		db 0
		
arrowBuf:	ds 16
