; === DEHRUST
; in	HL = packed data
;	DE = adr to depack

deHrust2:				
		ld	a, (hl)
		inc	hl
		cp	68h
		ret	nz
		ld	a, (hl)
		inc	hl
		cp	72h
		ret	nz
		ld	a, (hl)
		inc	hl
		cp	32h
		ret	nz
		ld	a, (hl)
		inc	hl
		rla
		ex	af, af'
		push	de
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		inc	hl
		dec	bc
		ex	de, hl
		add	hl, bc
		ex	de, hl
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		add	hl, bc
		sbc	hl, de
		add	hl, de
		jr	c, loc_764B
		ld	d, h
		ld	e, l
loc_764B:				
		push	bc
		lddr
		pop	bc
		ex	de, hl
		ex	af, af'
		jr	nc, loc_7658
		pop	de
		inc	hl
		ldir
		ret
loc_7658:				
		ld	de, 7
		add	hl, de
		push	hl
		exx
		pop	hl
		pop	de
		ld	a, 3
loc_7662:				
		dec	hl
		ld	b, (hl)
		dec	hl
		ld	c, (hl)
		push	bc
		dec	a
		jr	nz, loc_7662
		ld	b, a
		exx
		ld	de, 1003h
		ld	c, 80h
loc_7671:				
		ld	a, (hl)
		inc	hl
		exx
		ld	(de), a
		inc	de
loc_7676:				
		exx
loc_7677:				
		sla	c
		jr	nz, loc_767F
		ld	c, (hl)
		inc	hl
		rl	c
loc_767F:				
		jr	c, loc_7671
		ld	b, 1
loc_7683:				
		ld	a, 40h
loc_7685:				
		sla	c
		jr	nz, loc_768D
		ld	c, (hl)
		inc	hl
		rl	c
loc_768D:				
		rla
		jr	nc, loc_7685
		cp	e
		jr	c, loc_7698
		add	a, b
		ld	b, a
		xor	d
		jr	nz, loc_7683
loc_7698:				
		add	a, b
		cp	4
		jr	z, loc_76EA
		adc	a, 0FFh
loc_769F:				
		cp	2
loc_76A1:				
		exx
		ld	c, a
		ld	h, 0FFh
		exx
		jr	c, loc_7704
		jr	z, loc_76D3
		sla	c
		jr	nz, loc_76B2
		ld	c, (hl)
		inc	hl
		rl	c
loc_76B2:				
		jr	c, loc_76D3
		ld	a, 7Fh
		ld	b, e
		djnz	loc_7706
loc_76B9:				
		djnz	loc_76DC
		ld	b, a
		sbc	a, a
loc_76BD:				
		sla	c
		jr	nz, loc_76C5
		ld	c, (hl)
		inc	hl
		rl	c
loc_76C5:				
		rla
		dec	a
		inc	b
		jr	nz, loc_76BD
		cp	0E1h
		jr	nz, loc_76D0
		ld	a, (hl)
		inc	hl
loc_76D0:				
		exx
		ld	h, a
		exx
loc_76D3:				
		ld	a, (hl)
		inc	hl
loc_76D5:				
		exx
		ld	l, a
		add	hl, de
		ldir
		jr	loc_7676
loc_76DC:				
		add	a, 6
		rla
		ld	b, a
loc_76E0:				
		ld	a, (hl)
		inc	hl
		exx
		ld	(de), a
		inc	de
		exx
		djnz	loc_76E0
		jr	loc_7677
loc_76EA:				
		sla	c
		jr	nz, loc_76F2
		ld	c, (hl)
		inc	hl
		rl	c
loc_76F2:				
		ld	a, d
		jr	nc, loc_7706
		ld	a, (hl)
		inc	hl
		cp	d
		jr	nc, loc_769F
		or	a
		jr	z, loc_7715
		exx
		ld	b, a
		exx
		ld	a, (hl)
		inc	hl
		jr	loc_76A1
loc_7704:				
		ld	a, 3Fh
loc_7706:				
		sla	c
		jr	nz, loc_770E
		ld	c, (hl)
		inc	hl
		rl	c
loc_770E:				
		rla
		jr	nc, loc_7706
		djnz	loc_76B9
		jr	loc_76D5
loc_7715:				
		ld	hl, 2758h
		exx
		ld	b, 3
		ex	de, hl
loc_771C:				
		pop	de
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		djnz	loc_771C
		ret
; End of function deHrust2
